#! /usr/bin/tclsh
# Permit to translate countries.csv (with fields delimited with ":") to 
# qsl.countries file

set fd [open "countries.csv"]
set fdout [open "countries.qsl" {WRONLY TRUNC}]
puts $fdout "#each line must be 72 chars long (including CARRIAGE RETURN)..........."
set i 0
while {[gets $fd line]>0} {
  set par [split $line {:}]
  set country [string tolower [lindex $par 0]]
  puts $fdout "[format "%-31s %-31s %07d" [lindex $par 0] [lindex $par 1] [lindex $par 2]]"
  if {![file isdirectory "html/$country"]} {
    puts -nonewline "Creating directory $country...."
    if {[catch "file mkdir html/$country" error]} {
      puts "ERROR: $error"
    } else {
      puts "Done!"
    }
  }
  incr i
}
close $fd
close $fdout
puts "written $i countries: filename must be [expr ($i+1)*72] bytes long."