<?php
function getcountries() {
  global $countries,$ncountries;
  $ncountries=0;
  /* open countries.qsl and get the list of coutries */
  $fd=fopen("../countries.qsl","r");
  if (!$fd) {
    echo "<p class=\"error\">Error opening countries.qsl file</p>";
    return -1;
  }
  $i=0;
  while (!feof($fd)) {
    $line=fgets($fd,256);
    if ($line[0]!='#' && sscanf($line,"%s %s %d\n",&$country,&$prefix,&$nqsl)==3) {
      $countries[$i++]=array($country,$prefix,$nqsl);
    }
    $ncountries=$i;
  }
  fclose($fd);
}


function listcountries($qsl) {
  global $countries,$ncountries;
  for ($i=0;$i<$ncountries;$i++) {
    if ($qsl) {
      if ($countries[$i][2]>0) {
        printf("<option value=\"%s\">%s (%s) [%d]",$countries[$i][0],$countries[$i][0],$countries[$i][1],$countries[$i][2]);
      }
    }
    else {
      printf("<option value=\"%s\">%s (%s)",$countries[$i][0],$countries[$i][0],$countries[$i][1]);
    }
  }
}


function listqslfmcountry($country) {
  /* List all QSL from the specified country */
  $fd=opendir("$country");
  while (($file = readdir($fd))!=false) {
    if (($len=strpos($file,".info"))>0) {
      $qslcall=substr($file,0,$len);
      $qsl=file("$country/$file");
      $count=count($qsl);
      if ($count%7==0) { /* file.info: 1=>qslcallsign 2=>tocallsign 3=>uploadfmcallsign 4=>date 5=> comments 6=>imagefilename 7=>number of votes */
        for($i=0;$i<$count;$i+=7) {
          $update=hexdec(trim($qsl[$i+3]));
          printf("<tr><td>QSL Callsign: <b>%s</b><br>To callsign: <b>%s</b><br><br>Uploaded from %s in date %s at %s<br><br><b>%s</b><br><br>\n",trim($qsl[$i]),trim($qsl[$i+1]),trim($qsl[$i+2]),date("M d, Y",$update),date("H:i:s",$update),trim($qsl[$i+4]));
          for ($j=1;$j<=$qsl[$i+6];$j<<=1)
            echo "<img src=\"star.png\" alt=\"*\">";
          printf(" Vote this QSL:<input type=\"checkbox\" name=\"vote[%s/%s:%d]\"><td><img src=\"%s/%s\" alt=\"%s QSL to %s\">\n",$country,strtolower(trim($qsl[$i])),$i+6,$country,trim($qsl[$i+5]),trim($qsl[$i]),trim($qsl[$i+1]));
        }
      }
    }
  }
  closedir($fd);
}

function listqslnew($lastconn) {
  /* List all QSL from the specified country */
  $nqsl=0;
  $fd=opendir(".");
  while (($file = readdir($fd))!=false) {
    if (is_dir($file)) {
      $fdc=opendir($file);
      while (($filec=readdir($fdc))!=false) {
        if (($len=strpos($filec,".info"))>0) {
          $qslcall=substr($filec,0,$len);
          $qsl=file("$file/$filec");
          $count=count($qsl);
          if ($count%7==0) { /* file.info: 1=>qslcallsign 2=>tocallsign 3=>uploadfmcallsign 4=>date 5=> comments 6=>imagefilename 7=>number of votes */
            for($i=0;$i<$count;$i+=7) {
              $update=hexdec(trim($qsl[$i+3]));
              if ($update>$lastconn-7200) {
                $nqsl++;
                printf("<tr><td>QSL Callsign: <b>%s</b><br>To callsign: <b>%s</b><br><br>Uploaded from %s in date %s at %s<br><br><b>%s</b><br><br>\n",trim($qsl[$i]),trim($qsl[$i+1]),trim($qsl[$i+2]),date("M d, Y",$update),date("H:i:s",$update),trim($qsl[$i+4]));
                for ($j=1;$j<=$qsl[$i+6];$j<<=1)
                  echo "<img src=\"star.png\" alt=\"*\">";
                printf(" Vote this QSL:<input type=\"checkbox\" name=\"vote[%s/%s:%d]\"><td><img src=\"%s/%s\" alt=\"%s QSL to %s\">\n",$file,strtolower(trim($qsl[$i])),$i+6,$file,trim($qsl[$i+5]),trim($qsl[$i]),trim($qsl[$i+1]));
              }
            }
          }
        }
      }
      closedir($fdc);
    }
  }
  closedir($fd);
  return $nqsl;
}

function addvote($par) {
  /* filename is compose by country/callsign:line, like "slovenia/s57npr:6" */
  $line=6;
  list($file,$line)=split(":",$par);
  $qsl=file("$file.info");
  $count=count($qsl);
  $fd=fopen("$file.info","w+");
  for ($i=0;$i<$line;$i++)
    fputs($fd,$qsl[$i]);
  $line=sprintf("%d\n",$qsl[$i++]+1);
  fputs($fd,$line);
  for (;$i<$count;$i++)
    fputs($fd,$qsl[$i]);
  fclose($fd);
}

function counter () {
  $counterfile="../qsl.counter";
  if (!file_exists($counterfile)) {
    $counter=0;
    $fd=fopen($counterfile,"w+");
  } else {
    $fd=fopen($counterfile,"r+");
    $buffer=fread($fd,8);
    $buffer[8]=0;
    sscanf($buffer,"%d",&$counter);
  }
  $counter++;
  echo "$counter";
  fseek($fd,0,SEEK_SET);
  $buffer=sprintf("%08d",$counter);
  fwrite($fd,$buffer,8);
  fclose($fd);
}



function updatecountries ($cmd, $par1, $par2, $par3) {
  /*  update countries.qsl file:
      cmd=1 => add 1 to the qsl in the country $par1

  */

  if ($cmd==1) {
    /* add 1 to the country $par1 */
    if (!is_writable("../countries.qsl")) {
      echo "<div class=\"error\">Opening qsl.contries file to update number of qsl is impossible!<br>Permission denied</div>";
      return;
    }
    $fd=fopen("../countries.qsl","r+");
    if (!$fd) {
      echo "<div class=\"error\">Opening qsl.contries file to update number of qsl is impossible!<br>Permission denied</div>";
      return;
    }
    $fpos=0;
    while (!feof($fd)) {
      $line=fgets($fd,80);
      if ($line[0]!='#' && sscanf($line,"%s %s %07d\n",&$country,&$prefix,&$nqsl)==3) {
        if (!strcasecmp($country,$par1)) {
          $buffer=sprintf("%-31s %-31s %07d\n",$country,$prefix,++$nqsl);
          fseek($fd,$fpos,SEEK_SET);
          fwrite($fd,$buffer,72);
          break;
        }
      }
      $fpos=ftell($fd);
    }
    fclose($fd);
  }
  /* other commands ?? */


}

?>
